﻿' Title    : sdxBaseEngine Class
' Name     : sdxResource
' Author   : Sascha Bajus
' Created  : 01/2009
' Copyright © 2009 Sascha Bajus

#Region "Copyright© Information (German)"
' Diese Software wird bereitgestellt "wie sie ist", ohne jegliche ausdrückliche oder 
' stillschweigende Gewährleistung. In keinem Fall kann der Author haftbar gemacht werden
' für Schäden, die aus der Nutzung dieser Software entstanden sind.
'
' Es ist erlaubt, diese Software für jeden Zweck zu nutzen, einschließlich der kommerziellen 
' Anwendungen, und sie zu verändern, vorbehaltlich der folgenden Einschränkungen: 
'
' 1. Der Ursprung dieser Software darf nicht falsch dargestellt werden; Sie dürfen nicht behaupten, 
'    dass Sie der Urheber der Original-Software sind. Wenn Sie diese Software in einem Produkt 

' 2. Altered-Source-Versionen müssen klar als solche gekennzeichnet, und dürfen nicht als 
'    Original-Software dargestellt werden.
'
' 3. Diese Informationen dürfen nicht entfernt oder geändert werden.
#End Region
#Region "Copyright© Information (English)"
' This software is provided 'as-is', without any express or implied warranty. In no event will 
' the authors be held liable for any damages arising from the use of this software.
'
' Permission is granted to anyone to use this software for any purpose, including commercial 
' applications, and to alter it and redistribute it freely, subject to the following restrictions:
'
' 1. The origin of this software must not be misrepresented; you must not claim that you wrote 
'    the original software. If you use this software in a product, an acknowledgment in the 
'    product documentation would be appreciated but is not required.
'
' 2. Altered source versions must be plainly marked as such, and must not be misrepresented 
'    as being the original software.
'
' 3. This notice may not be removed or altered from any source distribution.
'
#End Region


Imports System.IO
Imports System.Resources
Imports sdxBaseEngine.SDX9BaseEngine


''' <summary>
''' Klasse zum Laden einer Resource
''' </summary>
Public Class engineResourceLoader
    Private ObjectName As New List(Of String)
    Private ObjectData As New List(Of Byte())
    Private Filesource As New List(Of String)
    Private CurrentName As String
    Private CurrentFile As String

    Public WriteOnly Property LoadResourceFile() As String
        Set(ByVal value As String)
            dxEngine.LoadingStatus = "Loading ResorceFile: " & value & "..."
            Try
                Dim file As String = value
                value = dxEngine.ApplicationPath & value
                Dim RSS As New ResourceSet(value)
                Dim i As Integer = 0
                For Each de As DictionaryEntry In RSS
                    ObjectName.Add(CStr(de.Key))
                    ObjectData.Add(CType(de.Value, Byte()))
                    Filesource.Add(file)
                Next
                RSS.Dispose()
            Catch ex As Exception
                dxEngine.EngineErrorDescription = "Error loading Resourcefile '" & value & "'"
            End Try
        End Set
    End Property

    ''' <summary>
    ''' Rückbage einer Resource aus dem ResourceSet als Bytebuffer
    ''' </summary>
    ''' <param name="objName">Name des Resourceobjektes</param>
    Public Function GetResourceObject(ByVal objName As String) As Byte()
        Dim found As Integer = -1
        For i = 0 To ObjectName.Count - 1
            If UCase(objName) = UCase(ObjectName.Item(i)) Then
                found = i
                Exit For
            End If
        Next

        If found < 0 Then
            CurrentName = ""
            CurrentFile = ""
            Return Nothing
        Else
            CurrentName = ObjectName(found)
            CurrentFile = Filesource(found)
            Return ObjectData.Item(found)
        End If
    End Function

    Public Function GetResourceObject(ByVal objIndex As Integer) As Byte()
        Try
            CurrentName = ObjectName(objIndex)
            CurrentFile = Filesource(objIndex)
            Return ObjectData.Item(objIndex)
        Catch ex As Exception
            CurrentName = ""
            CurrentFile = ""
            Return Nothing
        End Try
    End Function

    Public ReadOnly Property currentResourceFile() As String
        Get
            Return CurrentFile
        End Get
    End Property
    Public ReadOnly Property currentObjectName() As String
        Get
            Return CurrentName
        End Get
    End Property
    Public Sub Clear()
        ObjectData.Clear()
        ObjectName.Clear()
        Filesource.Clear()
    End Sub
End Class
