﻿Imports SlimDX
Imports SlimDX.Direct3D9
Imports sdxBaseEngine.SDX9BaseEngine

Public Class enginevbuffers
    Private _quadbuffer As sdxVBQuad
    Private _fsbuffer As sdxVBFS


#Region "Event Handles"
    Public Sub New()
        AddHandler dxLoadDeviceObjects, AddressOf LoadDeviceObjects
        AddHandler dxDeviceLost, AddressOf DeviceLost
        AddHandler dxDeviceReset, AddressOf DeviceReset
        AddHandler dxEngineClosing, AddressOf Dispose
    End Sub

    Private Sub LoadDeviceObjects()
        dxEngine.LoadingStatus = "Loading Engine: VBuffers..."
        _quadbuffer = New sdxVBQuad
        _fsbuffer = New sdxVBFS
    End Sub
    Private Sub DeviceLost()
        Dispose()
        _quadbuffer = Nothing
        _fsbuffer = Nothing
    End Sub
    Private Sub DeviceReset()
        _quadbuffer = New sdxVBQuad
        _fsbuffer = New sdxVBFS
    End Sub
    Private Sub Dispose()
        If Not _fsbuffer Is Nothing Then _fsbuffer.Dispose()
        If Not _quadbuffer Is Nothing Then _quadbuffer.Dispose()
    End Sub
#End Region

    Public ReadOnly Property Quad() As sdxVBQuad
        Get
            Return _quadbuffer
        End Get
    End Property
    Public ReadOnly Property FullScreen() As sdxVBFS
        Get
            Return _fsbuffer
        End Get
    End Property
End Class



