﻿' Title    : sdxBaseEngine Framework
' Name     : engineZBuffer
' Property : dxZBuffer
' Author   : Sascha Bajus
' Created  : 01/2009
' Copyright © 2009 Sascha Bajus

#Region "Copyright© Information (German)"
' Diese Software wird bereitgestellt "wie sie ist", ohne jegliche ausdrückliche oder 
' stillschweigende Gewährleistung. In keinem Fall kann der Author haftbar gemacht werden
' für Schäden, die aus der Nutzung dieser Software entstanden sind.
'
' Es ist erlaubt, diese Software für jeden Zweck zu nutzen, einschließlich der kommerziellen 
' Anwendungen, und sie zu verändern, vorbehaltlich der folgenden Einschränkungen: 
'
' 1. Der Ursprung dieser Software darf nicht falsch dargestellt werden; Sie dürfen nicht behaupten, 
'    dass Sie der Urheber der Original-Software sind. Wenn Sie diese Software in einem Produkt 

' 2. Altered-Source-Versionen müssen klar als solche gekennzeichnet, und dürfen nicht als 
'    Original-Software dargestellt werden.
'
' 3. Diese Informationen dürfen nicht entfernt oder geändert werden.
#End Region
#Region "Copyright© Information (English)"
' This software is provided 'as-is', without any express or implied warranty. In no event will 
' the authors be held liable for any damages arising from the use of this software.
'
' Permission is granted to anyone to use this software for any purpose, including commercial 
' applications, and to alter it and redistribute it freely, subject to the following restrictions:
'
' 1. The origin of this software must not be misrepresented; you must not claim that you wrote 
'    the original software. If you use this software in a product, an acknowledgment in the 
'    product documentation would be appreciated but is not required.
'
' 2. Altered source versions must be plainly marked as such, and must not be misrepresented 
'    as being the original software.
'
' 3. This notice may not be removed or altered from any source distribution.
'
#End Region


Imports SlimDX
Imports SlimDX.Direct3D9
Imports sdxBaseEngine.SDX9BaseEngine

''' <summary>
''' Property Class des ZBuffers
''' </summary>
''' <remarks></remarks>
Public Class engineZBuffer
    '''<summary>
    '''Aktivieren oder Deaktivieren den ZBuffer
    '''</summary>
    Public WriteOnly Property Enabled() As Boolean
        Set(ByVal value As Boolean)
            dxDevice.SetRenderState(RenderState.ZEnable, value)
            dxDevice.SetRenderState(RenderState.ZWriteEnable, value)
        End Set
    End Property

    '''<summary>
    '''Aktivieren oder Deaktivieren das Schreiben in den ZBuffer
    '''</summary>
    Public WriteOnly Property WriteEnabled() As Boolean
        Set(ByVal value As Boolean)
            dxDevice.SetRenderState(RenderState.ZWriteEnable, value)
        End Set
    End Property
    ''' <summary>
    ''' Legt die Funktionsweise des Zbuffers fest.
    ''' (Default LessEqual)
    ''' </summary>
    Public WriteOnly Property ZFunction() As Compare
        Set(ByVal value As Compare)
            dxDevice.SetRenderState(RenderState.ZFunc, value)
        End Set
    End Property
    ''' <summary>
    ''' Löscht den ZBuffer
    ''' </summary>
    Public Sub clear()
        dxDevice.Clear(ClearFlags.ZBuffer, 0, 1, 0)
    End Sub
End Class
