﻿' Title    : sdxBaseEngine Framework
' Author   : Sascha Bajus
' Created  : 01/2009
' Copyright © 2009 Sascha Bajus

#Region "Copyright© Information (German)"
' Diese Software wird bereitgestellt "wie sie ist", ohne jegliche ausdrückliche oder 
' stillschweigende Gewährleistung. In keinem Fall kann der Author haftbar gemacht werden
' für Schäden, die aus der Nutzung dieser Software entstanden sind.
'
' Es ist erlaubt, diese Software für jeden Zweck zu nutzen, einschließlich der kommerziellen 
' Anwendungen, und sie zu verändern, vorbehaltlich der folgenden Einschränkungen: 
'
' 1. Der Ursprung dieser Software darf nicht falsch dargestellt werden; Sie dürfen nicht behaupten, 
'    dass Sie der Urheber der Original-Software sind. Wenn Sie diese Software in einem Produkt 

' 2. Altered-Source-Versionen müssen klar als solche gekennzeichnet, und dürfen nicht als 
'    Original-Software dargestellt werden.
'
' 3. Diese Informationen dürfen nicht entfernt oder geändert werden.
#End Region
#Region "Copyright© Information (English)"
' This software is provided 'as-is', without any express or implied warranty. In no event will 
' the authors be held liable for any damages arising from the use of this software.
'
' Permission is granted to anyone to use this software for any purpose, including commercial 
' applications, and to alter it and redistribute it freely, subject to the following restrictions:
'
' 1. The origin of this software must not be misrepresented; you must not claim that you wrote 
'    the original software. If you use this software in a product, an acknowledgment in the 
'    product documentation would be appreciated but is not required.
'
' 2. Altered source versions must be plainly marked as such, and must not be misrepresented 
'    as being the original software.
'
' 3. This notice may not be removed or altered from any source distribution.
'
#End Region


Imports SlimDX
''' <summary>
''' Die Klasse speichert die Position und Skalierung eines Objekts und kann über eine 
''' Radiusangabe eine Bounding - Sphere erstellen.
''' </summary>
''' <remarks></remarks>
Public Class sdxSphereBoundObject

    Private _BoundingSphereRadius As Single
    Private _ObjectScale As Vector3
    Private _ObjectScaleS As Single
    Private _ObjectPosition As Vector3

    ''' <summary>
    ''' Erstellt eine neue SphereBoundObejct Klasse
    ''' </summary>
    ''' <param name="ObjectScale">Legt die Skalierungswerte für eine Transformation fest(als Vector3)</param>
    ''' <param name="ObjectPosition">Legt die Objektposition fest</param>
    ''' <param name="BoundingSphereRadius">Legt den Radius der Sphere, die das Objekt umschließt, fest</param>
    Public Sub New(ByVal ObjectScale As Vector3, ByVal ObjectPosition As Vector3, ByVal BoundingSphereRadius As Single)
        _BoundingSphereRadius = BoundingSphereRadius
        _ObjectScale = ObjectScale
        _ObjectPosition = ObjectPosition
    End Sub

    ''' <summary>
    ''' Erstellt eine neue SphereBoundObejct Klasse
    ''' </summary>
    ''' <param name="ObjectScale">Legt die Skalierungswerte für eine Transformation fest (als Single)</param>
    ''' <param name="ObjectPosition">Legt die Objektposition fest</param>
    ''' <param name="BoundingSphereRadius">Legt den Radius der Sphere, die das Objekt umschließt, fest</param>
    Public Sub New(ByVal ObjectScale As Single, ByVal ObjectPosition As Vector3, ByVal BoundingSphereRadius As Single)
        _BoundingSphereRadius = BoundingSphereRadius
        _ObjectScaleS = ObjectScale
        _ObjectPosition = ObjectPosition
    End Sub
    ''' <summary>
    ''' Rückgabe der BoundingSphere zur Kollisionsabfrage
    ''' </summary>
    Public ReadOnly Property BoundingSphere() As BoundingSphere
        Get
            Return New BoundingSphere(_ObjectPosition, _BoundingSphereRadius)
        End Get
    End Property
    ''' <summary>
    ''' ruft die Position des Objekts ab oder legt diese fest
    ''' </summary>
    ''' <value></value>
    Public Property Position() As Vector3
        Get
            Return _ObjectPosition
        End Get
        Set(ByVal value As Vector3)
            _ObjectPosition = value
        End Set
    End Property
    ''' <summary>
    ''' Rückgabe der Skalierung des Objekts (Vector3)
    ''' </summary>
    Public ReadOnly Property ScalingVector() As Vector3
        Get
            Return _ObjectScale
        End Get
    End Property
    ''' <summary>
    ''' Rückgabe der Skalierung des Objekts (Single)
    ''' </summary>
    Public ReadOnly Property Scaling() As Single
        Get
            Return _ObjectScaleS
        End Get
    End Property
End Class
