
const float2 offsets[14] = {
  float2( -7.00f, 0.00251782f),
  float2( -6.00f, 0.00763919f),
  float2( -5.00f, 0.01953944f),
  float2( -4.00f, 0.04213273f),
  float2( -3.00f, 0.07658962f),
  float2( -2.00f, 0.11737160f),
  float2( -1.00f, 0.15163480f),
  float2(  1.00f, 0.15163480f),
  float2(  2.00f, 0.11737160f),
  float2(  3.00f, 0.07658962f),
  float2(  4.00f, 0.04213273f),
  float2(  5.00f, 0.01953944f),
  float2(  6.00f, 0.00763919f),
  float2(  7.00f, 0.00251782f)
};

float2 OffsetSize;

//GlowMap
Texture GlowMap;
sampler GlowMapSampler=sampler_state { texture= <GlowMap>;
                                          minfilter = LINEAR;
                                          magfilter = LINEAR;
                                          mipfilter = NONE;
                                          AddressU  = MIRROR;
                                          AddressV  = MIRROR;};

//Vertex Output Structure
struct VS_OUTPUTGLOW
{
  float4 pos        : POSITION;		//Vertexposition
  float2 tex        : TEXCOORD0;	//Texcoords Reflectionmap
};

// ---------------------------------------------------------------------
//  VertexShaderGlow
// ---------------------------------------------------------------------

VS_OUTPUTGLOW vsGlow  (float4 pos :POSITION)
{
  VS_OUTPUTGLOW Out;
  Out.pos	      = float4 (pos.xy,0,1);
  Out.tex         = pos.zw;
  return Out;
}

// ---------------------------------------------------------------------
//  PixelShaderGlow
// ---------------------------------------------------------------------
float4 psGlow(float2 tex :TEXCOORD0, uniform float2 direction) : COLOR
{
  float4 g=tex2D(GlowMapSampler, tex);
	for(int i = 0; i < 14; i++)
		{
		float4 gtemp = tex2D(GlowMapSampler, tex + offsets[i].x * direction * OffsetSize);
		g += gtemp * offsets[i].y ;
		}
return g;
//return (s/13 - 0.17) *2.5;
}
