// -----------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------

matrix   WorldViewProjection;		//WorldViewProjection Matrix


//ColorMap
Texture ColorMap;
sampler ColorMapSampler=sampler_state { texture   = <ColorMap>;
		 								minfilter = LINEAR;
		 								magfilter = LINEAR;
		 								mipfilter = LINEAR;
		 								AddressU  = Clamp;
		 								AddressV  = Clamp;};




//Vertex Output Structure
struct VS_OUTPUT 
{
   float4 pos				: POSITION;			//Position 
   float2 tex				: TEXCOORD0;		//Texture 
};

// -----------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------


VS_OUTPUT vsout(float4 pos :POSITION, float3 N :NORMAL, float2 tex :TEXCOORD0)
{
  VS_OUTPUT Out;
  Out.pos   = mul(pos,WorldViewProjection);
  Out.tex   = tex;		                                
  return Out;
}
// -----------------------------------------------------------------------------------------------------------------
float4 psout(float2 tex :TEXCOORD0) : COLOR
{
 
  float4 color = tex2D(ColorMapSampler, tex);
  return color;
}
// -----------------------------------------------------------------------------------------------------------------
technique AlphaBox
{
   pass pass0
   {
        AlphaBlendEnable =true;
   		SrcBlend = SrcAlpha;
  	 	DestBlend = InvSrcAlpha;
  		ZEnable = true;
        ZWriteEnable =false;
      	VertexShader = compile vs_2_0 vsout();
      	PixelShader  = compile ps_2_0 psout();
   }
}
// -----------------------------------------------------------------------------------------------------------------
