

//Map
Texture ColorMap0;
sampler ColorMapSampler=sampler_state { texture   = <ColorMap0>;
                                          minfilter = LINEAR;
                                          magfilter = LINEAR;
                                          mipfilter = NONE;
                                          AddressU  = Clamp;
                                          AddressV  = Clamp;};

//Vertex Output Structure
struct VS_OUTPUT {
   float4 pos				: POSITION;
   float2 tex				: TEXCOORD0;
};


// -----------------------------------------------------------------------------------------------------------------
// VertexShader Section
// -----------------------------------------------------------------------------------------------------------------

 VS_OUTPUT vsout(float4 pos :POSITION)
{
  VS_OUTPUT Out;
  Out.pos   = float4(pos.xy,0,1); 	//Out - Position in ClipSpace
  Out.tex   = pos.zw;				//Out - TextureCoords
  return Out;
}
// - End -



// -----------------------------------------------------------------------------------------------------------------
//  FS/FSAlpha
// -----------------------------------------------------------------------------------------------------------------
float4 psout(float2  tex :TEXCOORD0) : COLOR
{
  float4 map=tex2D(ColorMapSampler, tex);
  return map;
}

// -----------------------------------------------------------------------------------------------------------------
//  Fog
// -----------------------------------------------------------------------------------------------------------------
float4 psoutFog(float2  tex :TEXCOORD0) : COLOR
{
  float4 map=tex2D(ColorMapSampler, tex);
  return map;
}


// ---------------------------------------------------------------------
//  Technique Section
// ---------------------------------------------------------------------

technique Bypass
{
   pass pass0
   {
      VertexShader = compile vs_1_1 vsout();
      PixelShader  = compile ps_2_0 psout();
   }
}
technique AlphaAdd
{
   pass pass0
   {  
      AlphaBlendEnable =true;
      AlphaTestEnable=true;
      AlphaRef = 10;
	  AlphaFunc = Greater;

      SrcBlend = ONE;
      DestBlend = ONE;
      ZEnable = true;
      ZWriteEnable =false;
      VertexShader = compile vs_1_1 vsout();
      PixelShader  = compile ps_2_0 psout();
   }
}
technique AlphaFog
{
   pass pass0
   {  
      AlphaBlendEnable =true;
      SrcBlend = SrcAlpha;
      DestBlend = InvSrcAlpha;
      ZEnable = true;
      ZWriteEnable =false;
      VertexShader = compile vs_1_1 vsout();
      PixelShader  = compile ps_2_0 psoutFog();
   }
}
